## postgresql-9.6 9.6.12

=== debian/changelog ===
postgresql-9.6 (9.6.12-0+deb9u1) stretch; urgency=medium

  * New upstream version.
  * Revert upstream patch "Disallow setting client_min_messages higher than
    ERROR", it causes to much disruption to existing (test) scripts.

 -- Christoph Berg <christoph.berg@credativ.de>  Fri, 15 Feb 2019 15:26:24 +0100

postgresql-9.6 (9.6.11-0+deb9u1) stretch; urgency=medium

  * New upstream version.

 -- Christoph Berg <christoph.berg@credativ.de>  Thu, 24 Jan 2019 14:36:40 +0100

postgresql-9.6 (9.6.10-0+deb9u1) stretch-security; urgency=medium

  * New upstream version.
    + Fix failure to reset libpq's state fully between connection attempts

      An unprivileged user of dblink or postgres_fdw could bypass the checks
      intended to prevent use of server-side credentials, such as a ~/.pgpass
      file owned by the operating-system user running the server.  Servers
      allowing peer authentication on local connections are particularly
      vulnerable.  Other attacks such as SQL injection into a postgres_fdw
      session are also possible. Attacking postgres_fdw in this way requires
      the ability to create a foreign server object with selected connection
      parameters, but any user with access to dblink could exploit the
      problem. In general, an attacker with the ability to select the
      connection parameters for a libpq-using application could cause
      mischief, though other plausible attack scenarios are harder to think
      of. Our thanks to Andrew Krasichkov for reporting this issue.
      (CVE-2018-10915)

    + Fix INSERT ... ON CONFLICT UPDATE through a view that isn't just SELECT
      FROM ...

      Erroneous expansion of an updatable view could lead to crashes or
      attribute ... has the wrong type errors, if the view's SELECT list
      doesn't match one-to-one with the underlying table's columns.
      Furthermore, this bug could be leveraged to allow updates of columns
      that an attacking user lacks UPDATE privilege for, if that user has
      INSERT and UPDATE privileges for some other column(s) of the table. Any
      user could also use it for disclosure of server memory. (CVE-2018-10925)

  * Add new pgtypes header and symbol.
  * Refresh debian/patches/filter-debug-prefix-map.
  * Update branch in Vcs-Git field.

 -- Christoph Berg <myon@debian.org>  Thu, 09 Aug 2018 23:22:41 +0200

postgresql-9.6 (9.6.9-0+deb9u1) stretch; urgency=medium

  * New upstream version.
    + Remove public execute privilege from contrib/adminpack's
      pg_logfile_rotate() function. (CVE-2018-1115)

    + Fix incorrect volatility and parallel-safety markings on a few built-in
      functions.

 -- Christoph Berg <christoph.berg@credativ.de>  Tue, 08 May 2018 16:22:51 +0200

postgresql-9.6 (9.6.8-0+deb9u1) stretch; urgency=medium

  * New upstream version.

    If you run an installation in which not all users are mutually
    trusting, or if you maintain an application or extension that is
    intended for use in arbitrary situations, it is strongly recommended
    that you read the documentation changes described in the first changelog
    entry below, and take suitable steps to ensure that your installation or
    code is secure.

    Also, the changes described in the second changelog entry below may
    cause functions used in index expressions or materialized views to fail
    during auto-analyze, or when reloading from a dump.  After upgrading,
    monitor the server logs for such problems, and fix affected functions.

    + Document how to configure installations and applications to guard
      against search-path-dependent trojan-horse attacks from other users

      Using a search_path setting that includes any schemas writable by a
      hostile user enables that user to capture control of queries and then
      run arbitrary SQL code with the permissions of the attacked user.  While
      it is possible to write queries that are proof against such hijacking,
      it is notationally tedious, and it's very easy to overlook holes.
      Therefore, we now recommend configurations in which no untrusted schemas
      appear in one's search path.
      (CVE-2018-1058)

    + Avoid use of insecure search_path settings in pg_dump and other client
      programs

      pg_dump, pg_upgrade, vacuumdb and other PostgreSQL-provided applications
      were themselves vulnerable to the type of hijacking described in the
      previous changelog entry; since these applications are commonly run by
      superusers, they present particularly attractive targets.  To make them
      secure whether or not the installation as a whole has been secured,
      modify them to include only the pg_catalog schema in their search_path
      settings. Autovacuum worker processes now do the same, as well.

      In cases where user-provided functions are indirectly executed by these
      programs -- for example, user-provided functions in index expressions --
      the tighter search_path may result in errors, which will need to be
      corrected by adjusting those user-provided functions to not assume
      anything about what search path they are invoked under.  That has always
      been good practice, but now it will be necessary for correct behavior.
      (CVE-2018-1058)

 -- Christoph Berg <christoph.berg@credativ.de>  Tue, 27 Feb 2018 13:14:39 +0100
