## postgresql-9.6 9.6.15

=== debian/changelog ===
postgresql-9.6 (9.6.15-1.pgdg90+1) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg.
  * Changes applied by generate-pgdg-source:
    + Moving lib packages to component 9.6.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 07 Aug 2019 14:07:29 +0200

postgresql-9.6 (9.6.15-1) unstable; urgency=medium

  * New upstream version.

    + Fixes regression in ALTER TABLE on multiple columns. (Closes: #932247)

    + Require schema qualification to cast to a temporary type when using
      functional cast syntax (Noah Misch)

      We have long required invocations of temporary functions to explicitly
      specify the temporary schema, that is pg_temp.func_name(args). Require
      this as well for casting to temporary types using functional notation,
      for example pg_temp.type_name(arg). Otherwise it's possible to capture a
      function call using a temporary object, allowing privilege escalation in
      much the same ways that we blocked in CVE-2007-2138. (CVE-2019-10208)

  * debian/pycompat: Obsolete, remove.
  * debian/patches: Add missing patch documentation.
  * debian/*.symbols: Add Build-Depends-Package information.
  * debian/tests: Also run regression tests.
  * debian/tests/control: Add fakeroot to dependencies.

 -- Christoph Berg <myon@debian.org>  Wed, 07 Aug 2019 14:07:29 +0200

postgresql-9.6 (9.6.14-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Tue, 18 Jun 2019 11:12:09 +0200

postgresql-9.6 (9.6.13-1) unstable; urgency=medium

  * New upstream version.
    + Prevent row-level security policies from being bypassed via selectivity
      estimators (Dean Rasheed)

      Some of the planner's selectivity estimators apply user-defined
      operators to values found in pg_statistic (e.g., most-common values).
      A leaky operator therefore can disclose some of the entries in a data
      column, even if the calling user lacks permission to read that column.
      In CVE-2017-7484 we added restrictions to forestall that, but we failed
      to consider the effects of row-level security.  A user who has SQL
      permission to read a column, but who is forbidden to see certain rows
      due to RLS policy, might still learn something about those rows'
      contents via a leaky operator.  This patch further tightens the rules,
      allowing leaky operators to be applied to statistics data only when
      there is no relevant RLS policy.  (CVE-2019-10130)

 -- Christoph Berg <myon@debian.org>  Tue, 07 May 2019 12:51:42 +0200

postgresql-9.6 (9.6.12-1) unstable; urgency=medium

  * New upstream version.
  * Drop explicit xz compression for .debs.
  * Depend on locales | locales-all. Suggested by Elrond, thanks!
    (Closes: #916655)
  * Build-Depend on tcl-dev instead of on a specific version.
  * initdb doesn't like LANG and LC_ALL to contradict, unset LANG and
    LC_CTYPE at test time. (Closes: #917764)
  * On purge, ask the user if they want to remove clusters. (Closes: #911940)

 -- Christoph Berg <christoph.berg@credativ.de>  Thu, 14 Feb 2019 15:23:49 +0100

postgresql-9.6 (9.6.11-1) unstable; urgency=medium

  * New upstream version.
  * Revert module_srcdir hack, rely on pg_buildext for reproducible PGXS
    module builds instead.
  * Enable dtrace support.
  * psql uses sensible-editor, depend on sensible-utils.
  * Add lintian overrides for plugins that link no external libraries.
  * configure: Hard-code paths to /bin/mkdir -p and /bin/tar.

 -- Christoph Berg <myon@debian.org>  Mon, 20 Aug 2018 12:26:08 +0200

postgresql-9.6 (9.6.10-1) unstable; urgency=medium

  * New upstream version.
    + Fix failure to reset libpq's state fully between connection attempts

      An unprivileged user of dblink or postgres_fdw could bypass the checks
      intended to prevent use of server-side credentials, such as a ~/.pgpass
      file owned by the operating-system user running the server.  Servers
      allowing peer authentication on local connections are particularly
      vulnerable.  Other attacks such as SQL injection into a postgres_fdw
      session are also possible. Attacking postgres_fdw in this way requires
      the ability to create a foreign server object with selected connection
      parameters, but any user with access to dblink could exploit the
      problem. In general, an attacker with the ability to select the
      connection parameters for a libpq-using application could cause
      mischief, though other plausible attack scenarios are harder to think
      of. Our thanks to Andrew Krasichkov for reporting this issue.
      (CVE-2018-10915)

    + Fix INSERT ... ON CONFLICT UPDATE through a view that isn't just SELECT
      FROM ...

      Erroneous expansion of an updatable view could lead to crashes or
      attribute ... has the wrong type errors, if the view's SELECT list
      doesn't match one-to-one with the underlying table's columns.
      Furthermore, this bug could be leveraged to allow updates of columns
      that an attacking user lacks UPDATE privilege for, if that user has
      INSERT and UPDATE privileges for some other column(s) of the table. Any
      user could also use it for disclosure of server memory. (CVE-2018-10925)

  * debian/rules: Set DEB_HOST_* via /usr/share/dpkg/architecture.mk.
  * Drop support for tcl8.5.
  * Remove version checking for libselinux1-dev, 2.1.10 is old enough now.
  * Refactor testsuite failure handling.
  * Use dh_auto_configure to correctly seed the build architecture.
  * Add new pgtypes header and symbol.
  * Filter -fdebug-prefix-map and -ffile-prefix-map in more places, and make
    PGXS modules build reproducibly.

 -- Christoph Berg <christoph.berg@credativ.de>  Tue, 07 Aug 2018 13:29:56 +0200

postgresql-9.6 (9.6.9-2) unstable; urgency=medium

  * Update libpq_pgport in Makefile.global to find libpgcommon/libpgport in
    pkglibdir.


