## postgresql-9.6 9.6.17

=== debian/changelog ===
postgresql-9.6 (9.6.17-0+deb9u1) stretch-security; urgency=medium

  * New upstream version.
    + Add missing permissions checks for ALTER ... DEPENDS ON EXTENSION.

      Marking an object as dependent on an extension did not have any
      privilege check whatsoever.  This oversight allowed any user to mark
      routines, triggers, materialized views, or indexes as droppable by
      anyone able to drop an extension.  Require that the calling user own the
      specified object (and hence have privilege to drop it). (CVE-2020-1720)

 -- Christoph Berg <myon@debian.org>  Tue, 11 Feb 2020 14:31:19 +0100

postgresql-9.6 (9.6.16-0+deb9u1) stretch; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Mon, 18 Nov 2019 11:25:55 +0100

postgresql-9.6 (9.6.15-0+deb9u1) stretch-security; urgency=medium

  * New upstream security release.
    + Fixes regression in ALTER TABLE on multiple columns. (Closes: #932247)

    + Require schema qualification to cast to a temporary type when using
      functional cast syntax (Noah Misch)

      We have long required invocations of temporary functions to explicitly
      specify the temporary schema, that is pg_temp.func_name(args). Require
      this as well for casting to temporary types using functional notation,
      for example pg_temp.type_name(arg). Otherwise it's possible to capture a
      function call using a temporary object, allowing privilege escalation in
      much the same ways that we blocked in CVE-2007-2138. (CVE-2019-10208)

  * On purge, ask the user if they want to remove clusters.
    (Closes: #911940, #933368)

 -- Christoph Berg <myon@debian.org>  Thu, 08 Aug 2019 15:55:21 +0200

postgresql-9.6 (9.6.13-0+deb9u1) stretch-security; urgency=medium

  * New upstream version.
    + Prevent row-level security policies from being bypassed via selectivity
      estimators (Dean Rasheed)

      Some of the planner's selectivity estimators apply user-defined
      operators to values found in pg_statistic (e.g., most-common values).
      A leaky operator therefore can disclose some of the entries in a data
      column, even if the calling user lacks permission to read that column.
      In CVE-2017-7484 we added restrictions to forestall that, but we failed
      to consider the effects of row-level security.  A user who has SQL
      permission to read a column, but who is forbidden to see certain rows
      due to RLS policy, might still learn something about those rows'
      contents via a leaky operator.  This patch further tightens the rules,
      allowing leaky operators to be applied to statistics data only when
      there is no relevant RLS policy.  (CVE-2019-10130)

  * Move maintainer address to tracker.

 -- Christoph Berg <myon@debian.org>  Tue, 07 May 2019 12:51:42 +0200
