=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Martin Pitt <mpitt@debian.org>,
  Peter Eisentraut <petere@debian.org>,
  Christoph Berg <myon@debian.org>
-Standards-Version: 4.3.0
+Standards-Version: 3.9.8
 Build-Depends:
  bison,
  debhelper (>= 9~),
@@ -35,18 +35,18 @@
  perl (>= 5.8),
  python-dev,
  python3-dev,
- systemtap-sdt-dev,
- tcl-dev,
+ tcl8.6-dev | tcl8.5-dev,
  uuid-dev,
  xsltproc,
  zlib1g-dev | libz-dev
 Homepage: http://www.postgresql.org/
-Vcs-Browser: https://salsa.debian.org/postgresql/postgresql
-Vcs-Git: https://salsa.debian.org/postgresql/postgresql.git -b 9.6
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-postgresql/postgresql.git/
+Vcs-Git: https://anonscm.debian.org/git/pkg-postgresql/postgresql.git -b 9.6-stretch
+XS-Testsuite: autopkgtest
 
 Package: libpq-dev
 Architecture: any
-Section: 9.6/libdevel
+Section: libdevel
 Depends:
  libpq5 (= ${binary:Version}),
  ${misc:Depends},
@@ -61,7 +61,7 @@
 
 Package: libpq5
 Architecture: any
-Section: 9.6/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
@@ -78,7 +78,7 @@
 
 Package: libecpg6
 Architecture: any
-Section: 9.6/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
@@ -90,7 +90,7 @@
 
 Package: libecpg-dev
 Architecture: any
-Section: 9.6/libdevel
+Section: libdevel
 Depends:
  libecpg-compat3 (= ${binary:Version}),
  libecpg6 (= ${binary:Version}),
@@ -110,7 +110,7 @@
 
 Package: libecpg-compat3
 Architecture: any
-Section: 9.6/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
@@ -122,7 +122,7 @@
 
 Package: libpgtypes3
 Architecture: any
-Section: 9.6/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
@@ -135,7 +135,7 @@
 Package: postgresql-9.6
 Architecture: any
 Depends:
- locales | locales-all,
+ locales,
  postgresql-client-9.6,
  postgresql-common (>= 171~),
  ssl-cert,
@@ -143,6 +143,7 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Recommends: postgresql-contrib-9.6, sysstat
+Suggests: locales-all
 Description: object-relational SQL database, version 9.6 server
  PostgreSQL is a powerful, open source object-relational database
  system. It is fully ACID compliant, has full support for foreign
@@ -173,7 +174,6 @@
 Depends:
  libpq5 (>= ${source:Upstream-Version}),
  postgresql-client-common (>= 142~),
- sensible-utils,
  ${misc:Depends},
  ${shlibs:Depends}
 Suggests: postgresql-9.6, postgresql-doc-9.6
@@ -331,4 +331,3 @@
  postgresql-9.6 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
-Provides: postgresql-pltcl
