=== debian/rules ===
--- 
+++ 
@@ -1,29 +1,41 @@
 #!/usr/bin/make -f
-
-include /usr/share/dpkg/architecture.mk
-
+ifneq ($(shell which tclsh8.6),)
+TCL_VER := 8.6
+else
+TCL_VER := 8.5
+endif
 MAJOR_VER := 9.6
 #CASSERT_FLAGS := --enable-cassert
 
 CATVERSION = $(shell awk '/CATALOG_VERSION_NO/ { print $$3 }' src/include/catalog/catversion.h)
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-#PIE# # On jessie/zesty and older, uncomment the #PIE# lines
-#PIE# # "-pie" because it would break linking our .so files
-#PIE# export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
+DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
+# find tclconfig in multi-arch location (still in /usr/lib in wheezy and precise)
+DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(TCL_VER)),)
+TCL_CONFIG_DIR := /usr/lib/$(DEB_HOST_MULTIARCH)
+else
+TCL_CONFIG_DIR := /usr/lib
+endif
+
+# "-pie" because it would break linking our .so files
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
-#PIE# # skip -pie on 32bit archs for performance and stability reasons
-#PIE# # (http://www.postgresql.org/message-id/20140519115318.GB7296@msgid.df7cb.de, #797530)
-#PIE# ifneq ($(DEB_HOST_ARCH_BITS || :),32)
-#PIE# CFLAGS+= -fPIC -pie
-#PIE# else
-#PIE# # if gcc recognizes -no-pie, add it to CFLAGS (exit is 4 for unknown options)
-#PIE# CFLAGS+= $(shell gcc -no-pie 2> /dev/null; [ $$? = 1 ] && echo "-no-pie")
-#PIE# endif
+LDFLAGS+= -Wl,--as-needed -L/usr/lib/mit-krb5 -L/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5
+CFLAGS+= -I/usr/include/mit-krb5
+# skip -pie on 32bit archs for performance and stability reasons
+# (http://www.postgresql.org/message-id/20140519115318.GB7296@msgid.df7cb.de, #797530)
+ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH_BITS || :),32)
+CFLAGS+= -fPIC -pie
+else
+# if gcc recognizes -no-pie, add it to CFLAGS (exit is 4 for unknown options)
+CFLAGS+= $(shell gcc -no-pie 2> /dev/null; [ $$? = 1 ] && echo "-no-pie")
+endif
 
 # Facilitate hierarchical profile generation on amd64 (#730134)
-ifeq ($(DEB_HOST_ARCH),amd64)
+ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),amd64)
 CFLAGS+= -fno-omit-frame-pointer
 endif
 
@@ -34,9 +46,14 @@
 SPINLOCK_FLAGS = --disable-spinlocks
 endif
 
-ifeq ($(DEB_HOST_ARCH_OS),linux)
+ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_OS),linux)
 SYSTEMD_FLAGS = --with-systemd
+# --with-selinux needs libselinux 2.1.10
+# (we don't put that in debian/control so we can use the same source also on older dists)
+SEVERSION = $(shell dpkg-query -f '$${Version}' --show libselinux1-dev)
+ifeq ($(shell dpkg --compare-versions "$(SEVERSION)" ge 2.1.10 && echo yes),yes)
 SELINUX_FLAGS= --with-selinux
+endif
 endif
 
 COMMON_CONFIGURE_FLAGS= \
@@ -54,7 +71,6 @@
   --enable-thread-safety \
   --enable-tap-tests \
   --enable-debug \
-  --enable-dtrace \
   $(CASSERT_FLAGS) \
   --disable-rpath \
   --with-uuid=e2fs \
@@ -62,23 +78,23 @@
   --with-pgport=5432 \
   --with-system-tzdata=/usr/share/zoneinfo \
   $(SYSTEMD_FLAGS) \
-  $(SELINUX_FLAGS) \
   $(SPINLOCK_FLAGS) \
-  MKDIR_P='/bin/mkdir -p' \
-  TAR='/bin/tar' \
   CFLAGS='$(CFLAGS)' \
-  LDFLAGS='$(LDFLAGS)' \
-  DPKG_VERSION=$(shell dpkg-parsechangelog | awk '/^Version:/ { print $$2 }') \
-  DPKG_VENDOR=$(shell dpkg-vendor --query vendor)
+  LDFLAGS='$(LDFLAGS)'
 
 # allow missing krb5 and ldap during bootstrapping
 ifeq ($(DEB_STAGE),stage1)
 BOOTSTRAP_FLAGS=
 else
-BOOTSTRAP_FLAGS= --with-gssapi --with-ldap \
-		 --with-includes=/usr/include/mit-krb5 \
-		 --with-libs=/usr/lib/mit-krb5 \
-		 --with-libs=/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5
+BOOTSTRAP_FLAGS= --with-krb5 --with-gssapi --with-ldap
+endif
+
+# build should fail on test suite failures on all arches
+TESTSUITE_FAIL_CMD=exit 1
+# hurd doesn't implement semaphores shared between processes yet; succeed anyway so they at least have libpq5
+# plperl currently fails on kfreebsd-*
+ifneq ($(filter $(DEB_HOST_ARCH), hurd-i386 kfreebsd-amd64 kfreebsd-i386),)
+TESTSUITE_FAIL_CMD=exit 0
 endif
 
 %:
@@ -88,8 +104,8 @@
 override_dh_auto_configure-arch: stamp/configure-build stamp/configure-build-py3
 
 stamp/configure-build:
-	mkdir -p stamp
-	dh_auto_configure --builddirectory=build -- \
+	mkdir -p stamp build
+	cd build && ../configure \
            --with-tcl \
            --with-perl \
            --with-python \
@@ -97,16 +113,19 @@
            --with-openssl \
            --with-libxml \
            --with-libxslt \
+           --with-tclconfig=$(TCL_CONFIG_DIR)/tcl$(TCL_VER) \
+           --with-includes=/usr/include/tcl$(TCL_VER) \
            PYTHON=/usr/bin/python \
            $(COMMON_CONFIGURE_FLAGS) \
-           $(BOOTSTRAP_FLAGS)
+           $(BOOTSTRAP_FLAGS) \
+           $(SELINUX_FLAGS)
 	# remove pre-built documentation
 	rm -fv doc/src/sgml/*-stamp
 	touch "$@"
 
 stamp/configure-build-py3:
-	mkdir -p stamp
-	dh_auto_configure --builddirectory=build-py3 -- \
+	mkdir -p stamp build-py3
+	cd build-py3 && ../configure \
            --with-python \
            PYTHON=/usr/bin/python3 \
            $(COMMON_CONFIGURE_FLAGS)
@@ -171,12 +190,6 @@
 	mkdir -p debian/postgresql-$(MAJOR_VER)/usr/share/doc/postgresql-$(MAJOR_VER)
 	ln -s ../postgresql-common/README.Debian.gz debian/postgresql-$(MAJOR_VER)/usr/share/doc/postgresql-$(MAJOR_VER)/README.Debian.gz
 
-	# remove actual build path from Makefile.global for reproducibility
-	sed -i -e "s!^abs_top_builddir.*!abs_top_builddir = /build/postgresql-$(MAJOR_VER)/build!" \
-	       -e "s!^abs_top_srcdir.*!abs_top_srcdir = /build/postgresql-$(MAJOR_VER)/build/..!" \
-	       -e 's!-f\(debug\|file\)-prefix-map=[^ ]* !!g' \
-	       debian/postgresql-server-dev-$(MAJOR_VER)/usr/lib/postgresql/$(MAJOR_VER)/lib/pgxs/src/Makefile.global
-
 	# these are shipped in the pl packages
 	rm debian/postgresql-contrib-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/extension/pl*
 	rm debian/postgresql-contrib-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/extension/*_pl*
@@ -197,13 +210,6 @@
 
 override_dh_auto_test-arch:
 ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
-	# when tests fail, print newest 3 log files
-	# initdb doesn't like LANG and LC_ALL to contradict, unset LANG and LC_CTYPE here
+	# when tests fail, print all regression.diffs files, as well as the newest log files
 	# temp-install wants to be invoked from a top-level make, unset MAKELEVEL here
-	# hurd doesn't implement semaphores shared between processes yet; succeed anyway so they at least have libpq5
-	# plperl currently fails on kfreebsd-*
-	unset LANG LC_CTYPE MAKELEVEL; if ! make -C build check-world EXTRA_REGRESS_OPTS='--port=$(shell perl -le 'print 1024 + int(rand(64000))')'; then \
-	    for l in `find build \( -name regression.diffs -o -name initdb.log -o -name postmaster.log \) | perl -we 'print map { "$$_\n"; } sort { (stat $$a)[9] <=> (stat $$b)[9] } map { chomp; $$_; } <>' | tail -3`; do \
-		echo "******** $$l ********"; \
-		cat $$l; \
-	    done; \
+	unset MAKELEVEL; if ! make -C build check-world EXTRA_REGRESS_OPTS='--port=$(shell perl -le 'print 1024 + int(rand(64000))')'; then \
